VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ERPSystemUpdate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Function ExtractUserInfo(ByVal strXML As String, _
                                 ByRef strFirstName As String, _
                                 ByRef strLastName As String, _
                                 ByRef strAlias As String, _
                                 ByRef strPhone As String, _
                                 ByRef strStreet As String, _
                                 ByRef strCity As String, _
                                 ByRef strZipCode As String, _
                                 ByRef strState As String, _
                                 ByRef strLevel As String, _
                                 ByRef strTitle As String, _
                                 ByRef strReturnPort As String)

Dim oXMLDom As MSXML2.DOMDocument
Dim oNode As IXMLDOMElement
Dim strAreaCode As String
Dim strNumber As String

On Error GoTo ExtractUserInfo_err

Set oXMLDom = CreateObject("MSXML2.DOMDocument")
oXMLDom.loadXML strXML

'Get the attribute values from the NAME Node of the XML Message
Set oNode = oXMLDom.getElementsByTagName("Name").Item(0)
strFirstName = oNode.getAttribute("First")
strLastName = oNode.getAttribute("Last")
strAlias = oNode.getAttribute("Alias")


'Get the attribute values from the ADDRESS Node of the XML Message
Set oNode = oXMLDom.getElementsByTagName("Address").Item(0)
strStreet = oNode.getAttribute("Street")
strCity = oNode.getAttribute("City")
strState = oNode.getAttribute("State")
strZipCode = oNode.getAttribute("ZipCode")

'Get the attribute values from the PHONE Node of the XML Message
Set oNode = oXMLDom.getElementsByTagName("Phone").Item(0)
strAreaCode = oNode.getAttribute("AreaCode")
strNumber = oNode.getAttribute("Number")
strPhone = strAreaCode & "-" & strNumber


'Get the attribute values from the LEVEL Node of the XML Message
Set oNode = oXMLDom.getElementsByTagName("Level").Item(0)
strLevel = oNode.getAttribute("Code")
strTitle = oNode.getAttribute("Title")

'Get the attribute values from the HEADER Node of the XML Message
Set oNode = oXMLDom.getElementsByTagName("HEADER").Item(0)
strReturnPort = oNode.getAttribute("ReturnPort")
strReturnPort = Replace(strReturnPort, "&", "&amp;")



ExtractUserInfo_exit:
  Set oNode = Nothing
  Set oXMLDom = Nothing
  Exit Function
  
ExtractUserInfo_err:
  Set oNode = Nothing
  Set oXMLDom = Nothing

  Err.Raise 1000 + Err.Number, Err.Source & ":ExtractUserInfo", Err.Description
  Exit Function
  
End Function

Private Function FormatFailedResponse(ByVal strLastName As String, ByVal strFirstName As String, ByRef strAlias As String, ByVal strPhone As String, ByVal strReturnPort As String, ByVal strDescription As String, ByRef strXMLResponse) As Boolean
Dim strMsg As String
Dim FailureCode As String
Dim strName As String

  FailureCode = "0"
  strName = strFirstName & " " & strLastName
  
  strMsg = "<?xml version = " & """1.0""?>" & vbNewLine
  strMsg = strMsg & "<ERPResponse>" & vbNewLine
  strMsg = strMsg & "<Employee Name=""" & strName & """ Alias=""" & strAlias & """/>" & vbNewLine
  strMsg = strMsg & "<Response ResponseCode=""" & FailureCode & """ Description=""" & strDescription & """/>" & vbNewLine
  strMsg = strMsg & "<RoutingInfo ReturnPort=""" & strReturnPort & """/>" & vbNewLine
  strMsg = strMsg & "</ERPResponse>"

  
  strXMLResponse = strMsg
End Function

Private Function FormatSuccessResponse(ByVal strLastName As String, ByVal strFirstName As String, ByRef strAlias As String, ByVal strPhone As String, ByVal strReturnPort As String, ByVal strDescription As String, ByRef strXMLResponse As String) As Boolean

Dim strMsg As String
Dim SuccessCode As String
Dim strName As String

  SuccessCode = "1"
  strName = strFirstName & " " & strLastName

  strMsg = "<?xml version = " & """1.0""?>" & vbNewLine
  strMsg = strMsg & "<ERPResponse>" & vbNewLine
  strMsg = strMsg & "<Employee Name=""" & strName & """ Alias=""" & strAlias & """/>" & vbNewLine
  strMsg = strMsg & "<Response ResponseCode=""" & SuccessCode & """ Description=""" & strDescription & """/>" & vbNewLine
  strMsg = strMsg & "<RoutingInfo ReturnPort=""" & strReturnPort & """/>" & vbNewLine
  strMsg = strMsg & "</ERPResponse>"
  
  strXMLResponse = strMsg
End Function


Public Function UpdateERPSystem(ByVal strUserInfo As String, _
                                ByVal strQueuePath As String) As String

Dim strLastName As String
Dim strFirstName As String
Dim strAlias As String
Dim strPhone As String
Dim strStreet As String
Dim strCity As String
Dim strZipCode As String
Dim strState As String
Dim strLevel As String
Dim strTitle As String
Dim strReturnPort As String
Dim status As Boolean
Dim strDescription As String
Dim strXMLResponse As String
Dim strResponse As String
Dim strQueueName As String
Dim strMsgLabel As String
Dim oTS As ADODB.Stream
Dim MsgText As String

On Error GoTo UpdateERPSystem_err

  'Debug lines
  App.LogEvent "Message Received by the COM Componenet ERPSystem." & vbNewLine & strUserInfo, vbLogEventTypeInformation
  SpitMsgToFile strUserInfo, "c:\temp\ERPSystemUpdate.xml"
  
  status = ExtractUserInfo(strUserInfo, strFirstName, strLastName, strAlias, strPhone, strStreet, strCity, strZipCode, strState, strLevel, strTitle, strReturnPort)
    
  status = InsertData(strLastName, strFirstName, strAlias, strPhone, strStreet, strCity, strState, strZipCode, strLevel, strTitle, strResponse)
  
  If status = True Then
    status = FormatSuccessResponse(strLastName, strFirstName, strAlias, strPhone, strReturnPort, strResponse, strXMLResponse)
  Else
    status = FormatFailedResponse(strLastName, strFirstName, strAlias, strPhone, strReturnPort, strResponse, strXMLResponse)
  End If
  
  If Not IsEmpty(strXMLResponse) Then
     SpitMsgToFile strXMLResponse, "c:\temp\ERPSystemResonse.xml"
  End If
     
UpdateERPSystem_exit:
    'Cleanup
    UpdateERPSystem = strXMLResponse
    Exit Function
    
UpdateERPSystem_err:
    App.LogEvent "Error occured in the ERP System." & vbNewLine & "Error = " & Err.Number & "Description = " & Err.Description, vbLogEventTypeError
    Exit Function

End Function


Private Function InsertData(ByVal strLastName As String, ByVal strFirstName As String, ByVal strAlias As String, ByVal strPhone As String, _
                            ByVal strStreet As String, ByVal strCity As String, ByVal strState As String, _
                            ByVal strZipCode As String, ByVal strLevel As String, ByVal strTitle As String, ByRef strResponse As String) As Boolean

  Dim oCnn As ADODB.Connection
  Dim oCmd As ADODB.Command
  
On Error GoTo InsertData_err

  Set oCnn = CreateObject("ADODB.Connection")
  
  oCnn.ConnectionString = "DSN=ERPsystem;UID=sa;PWD="
  oCnn.Open
  
  Set oCmd = CreateObject("ADODB.Command")
  oCmd.ActiveConnection = oCnn
  oCmd.CommandType = adCmdStoredProc
  oCmd.CommandText = "erpsys_createUser"
  
  oCmd.Parameters.Refresh
  
  With oCmd.Parameters
    .Item("@alias").Value = strAlias
    .Item("@firstName").Value = strFirstName
    .Item("@lastName").Value = strLastName
    .Item("@phone").Value = strPhone
    .Item("@street").Value = strStreet
    .Item("@city").Value = strCity
    .Item("@zipcode").Value = strZipCode
    .Item("@state").Value = strState
    .Item("@level").Value = strLevel
    .Item("@title").Value = strTitle
  End With
    
  oCmd.Execute
  
InsertData_exit:
  strResponse = "Successfully Created New Hire " & strFirstName & " " & strLastName & " in the ERP System"
  InsertData = True
  Exit Function
  
InsertData_err:
  strResponse = Err.Description
  InsertData = False
  Exit Function
  
  
End Function


Private Function DropResponseToQueue(ByVal strQueueName As String, ByVal strMsgLabel As String, ByVal strResponseCSV As String) As Boolean

  Dim qry As MSMQQuery
  
  Dim qi As MSMQQueueInfo
  Dim XMLDataFile As String
  Dim q As MSMQQueue
  Dim qis As MSMQQueueInfos

  
  On Error GoTo DropResponseToQueue_err
    
  'Check to see if the Queue exists in the Public Queue
  Set qi = New MSMQ.MSMQQueueInfo
  qi.PathName = strQueueName
  Set q = qi.Open(MQ_SEND_ACCESS, MQ_DENY_NONE)
    
  Dim msg As MSMQMessage
  Set msg = New MSMQMessage
  msg.Label = strMsgLabel
  msg.Priority = MQ_MAX_PRIORITY
  msg.Body = strResponseCSV
  msg.Send q

DropResponseToQueue_exit:

  q.Close
  Set q = Nothing
  Exit Function
  
DropResponseToQueue_err:
 
  Exit Function
End Function


Private Function SpitMsgToFile(ByVal strMsg As String, ByVal strFileName As String)

Dim ofd As Scripting.FileSystemObject
Dim oTS As Scripting.TextStream

Set ofd = CreateObject("Scripting.FileSystemObject")
Set oTS = ofd.CreateTextFile(strFileName)

oTS.Write strMsg
oTS.Close

Set oTS = Nothing
Set ofd = Nothing

End Function

Private Function SendERPResponseHTTP(ByVal strMsg As String, ByVal strReturnPort As String)

On Error GoTo SendERPResponseHTTP_err

Dim strResponseText As String
Dim strResponseBody As String

Dim oHTTP As MSXML2.XMLHTTP
    
    'Send the Message via HTTP to the RetrunPort. If the ReturnPort is empty then flag error
    If Not IsEmpty(strReturnPort) Then
      
      Set oHTTP = CreateObject("Microsoft.XMLHTTP")
      oHTTP.Open "POST", strReturnPort, False
      oHTTP.setRequestHeader "Content-Type", "text/xml"
      oHTTP.Send strMsg
      
      strResponseText = oHTTP.responseText
      strResponseBody = oHTTP.responseBody
      
    Else
      Err.Raise 999, "SendERPResponseHTTP", "No HTTP URL found"
    End If
    
    
SendERPResponseHTTP_exit:

    Exit Function
    
SendERPResponseHTTP_err:
    App.LogEvent "Error = " & Err.Number & ", Description = " & Err.Description, vbLogEventTypeError
    Err.Raise 999, Err.Source & ": SendERPResponseHTTP()", Err.Description
    Exit Function

End Function


